<template>
    <component
      :is="componentName"
      v-bind="componentProps"
      class="ui-clickable"
      @click="handleClick"
    >
      <slot />
    </component>
  </template>
  
  <script lang="ts">
    import type { UiClickableHrefProp, UiClickableProps, UiClickableTargetProp, UiClickableToProp, UiClickableTypeProp } from './types'
    import { computed, defineComponent, PropType } from 'vue'
  
    export default defineComponent({
      name: 'ui-clickable',
      inheritAttrs: true,
      props: {
        type: {
          type: String as PropType<UiClickableTypeProp>,
        },
        target: {
          type: String as PropType<UiClickableTargetProp>,
        },
        disabled: {
          type: Boolean,
          default: false,
        },
        to: {
          type: Object as PropType<UiClickableToProp>,
        },
        href: {
          type: String as PropType<UiClickableHrefProp>,
        },
      },
      setup(props) {
        const componentProps = computed(() => {
          const buttonProps: UiClickableProps = {}
  
          if (props.to) {
            buttonProps.to = props.to
          } else if (props.href) {
            buttonProps.target = props.target
            buttonProps.href = props.href
          } else {
            buttonProps.type = props.type ?? 'button'
            buttonProps.disabled = props.disabled
          }
  
          return buttonProps
        })
  
        const componentName = computed(() => {
          return props.to ? 'router-link' : (props.href ? 'a' : 'button')
        })
  
        const handleClick = (event: Event) => {
          if (props.disabled) {
            event.preventDefault()
            event.stopPropagation()
          }
        }
  
        return {
          componentProps,
          componentName,
          handleClick,
        }
      },
    })
  </script>
  